#pragma once
#include "Message.h"
#include <string>
#include <iostream>

namespace com{
namespace softwareag{
namespace umtransport{
namespace samples{
namespace echo{

class SimpleMessage : public com::softwareag::umtransport::samples::Message
{
public:
	SimpleMessage();
	SimpleMessage(std::string text);
	virtual ~SimpleMessage();
	void writeOut(com::softwareag::umtransport::SynchronousTransport::OutputStream &outputStream);
	void readIn(com::softwareag::umtransport::SynchronousTransport::InputStream &inputStream);

	friend std::ostream & operator<<(std::ostream & _stream, SimpleMessage const & mc){
		_stream << mc.m_text << std::endl;
		return _stream;
	}

private:
	std::string m_text;
};
}}}}}
