#pragma once

#include "Poco/Runnable.h"
#include "BroadcastMessage.h"
#include "SynchronousClient.h"

namespace com{
namespace softwareag{
namespace umtransport{
namespace samples{
namespace broadcaster{
class SynchronousBroadcasterClient : public Poco::Runnable{

public:
	SynchronousBroadcasterClient(std::shared_ptr<SynchronousClient<BroadcastMessage>> client);
	virtual ~SynchronousBroadcasterClient();
	virtual void run();
	virtual void shutdown();

	static int main (int argc, char** argv);

private:
	std::shared_ptr<SynchronousClient<BroadcastMessage>> m_client;
	bool canRun;

};
}}}}}
