#pragma once

#include "Poco/Process.h"
#include "Poco/Pipe.h"

#include <string>

namespace com {
namespace pcbsys {
namespace nirvana {
namespace client {
namespace p2p {
class nStreamService;
}
}
namespace apps {
using namespace com::pcbsys::nirvana::client::p2p;
using namespace Poco;

class PipeStream;

class ShellServer {
  public:
    ShellServer(std::string *pRprops, int nProp, std::string& shell);
    virtual ~ShellServer(void);

  private:
    static ShellServer* m_pSelf;
};

class handler {
  private:
    nStreamService *m_pService;

    Pipe m_inPipe;
    Pipe m_outPipe;
    Pipe m_errPipe;

    PipeStream *m_pInStream;
    PipeStream *m_pOutStream;

  public:
    handler(ShellServer *pSs, nStreamService *pServ, std::string& shell);

    bool m_bIsClosed;
    Process *m_pProcess;
    Process::PID m_id;
};

}
}
}
}
