#include "Observer.h"

#include <string>

namespace com {
namespace pcbsys {
namespace nirvana {
namespace nAdminAPI {
class nConfigGroup;
class nConfigEntry;

namespace apps {

using namespace com::pcbsys::foundation::fbase;

class realmconfig : public Observer {
  public:
    realmconfig(int argc, char** argv);

    virtual void update(Observable *pObs, void *pObj);

  private:
    void displayGroups(nConfigGroup *pGrp);
    void displayEntry(nConfigEntry *pEnt);
    virtual void getOptions(int argc, char** argv);
    static void Usage();

    std::string m_realmUrl;
};

}
}
}
}
}
